;
;				Bibliography
;
; 1. Windows Assembly Language and Systems Programming, R&D Books
; Lawrence, Kansas, Kauler, 1997.
;
; 2. Mastering Turbo Assembler, Sams Publishing, Indianapolis,
; Indiana, Swam, 1995.
;
TITLE FREEHAFER'S 16 BIT WINDOWS TASM CALCULATOR PROGRAM
;.........................................................................
.MODEL SMALL
;.........................................................................
EXTRN DOS3CALL:FAR, CALLWINDOWPROC:FAR, WINEXEC:FAR, SETTIMER:FAR, KILLTIMER:FAR, SNDPLAYSOUND:FAR, SETFOCUS:FAR, SENDMESSAGE:FAR, UPDATEWINDOW:FAR, BEGINPAINT:FAR, ENDPAINT:FAR, DEFWINDOWPROC:FAR, POSTQUITMESSAGE:FAR, REGISTERCLASS:FAR, CREATEWINDOW:FAR, SHOWWINDOW:FAR, GETMESSAGE:FAR, LOADCURSOR:FAR, TRANSLATEMESSAGE:FAR, DISPATCHMESSAGE:FAR, LOADICON:FAR, TEXTOUT:FAR, MESSAGEBOX:FAR
;.........................................................................
.DATA
;.......................miscellaneous
	szWindowTitle	DB	'FREEHAFER''S 16 BIT TASM CALCULATOR PROGRAM RUNS IN WINDOWS 2000!', 0
	szName		DB	'z', 0		; program has name so menu from *.rc attaches
	ICON_ROAK		DB	'z.icon', 0		; path of icon
	hInstance		DW	0			; handle from winmain for child windows
	FirstString		DB	'2002 INNIEA PUBLISHING COMPANY!    RK NOG!', 0
	wave_path		DB	'roak.wav', 0
	calc_path		DB	'C:\WINNT\SYSTEM32\CALC.EXE', 0
	calc_path_w		DB	'C:\WINDOWS\CALC.EXE', 0
	INPUT			DB	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
	counter		DW	0
	button_number	DW	0
	first_operand	DW	0
	second_operand	DW	0		
	which_operand	DB	0
	what_operation	DW	0		; + - x 
;.......................messageboxes
	AboutMessage	DB	'THIS PROGRAM WAS COMPILED WITH TASM VERSION 5.', 10, 13, 10, 13, '2000 INNIEA PUBLISHING COMPANY!  RK NOG!', 0
	AboutTitle		DB	'ABOUT MESSAGEBOX TITLE', 0
	InfoMessage		DB	'DO NOT RELY ON THIS CALCULATOR FOR ACCURATE RESULTS.', 10, 13, 10, 13, 'DECIMAL POINTS ARE BETTER LEFT TO ANOTHER COMPUTER LANGUAGE.', 10, 13, 10, 13, 'MAXIMUM INPUT OR OUTPUT VALUES ARE 65535.', 10, 13, 10, 13, 'TO STOP OBNOXIOUS BEEPING RIGHT CLICK MOUSE ON CALCULATOR WINDOW OUTSIDE OF A BUTTON AREA.', 0
	InfoTitle		DB	'IMPORTANT INFORMATION', 0
	WarningMessage	DB	'FILE NOT FOUND!', 0
	WarningTitle	DB	'WARNING!', 0
;.......................buttons
	BUTTON_HANDLE_1	DW	0
	BUTTON_HANDLE_2	DW	0
	BUTTON_HANDLE_3	DW	0
	BUTTON_HANDLE_4	DW	0
	BUTTON_HANDLE_5	DW	0
	BUTTON_HANDLE_6	DW	0
	BUTTON_HANDLE_7	DW	0
	BUTTON_HANDLE_8	DW	0
	BUTTON_HANDLE_9	DW	0
	BUTTON_HANDLE_0	DW	0
	BUTTON_HANDLE_A	DW	0
	BUTTON_HANDLE_S	DW	0
	BUTTON_HANDLE_M	DW	0
	BUTTON_HANDLE_D	DW	0
	BUTTON_HANDLE_P	DW	0
	BUTTON_HANDLE_E	DW	0
	Button_msg_1	DB	'1 ONE', 0
	Button_msg_2	DB	'2 TWO', 0
	Button_msg_3	DB	'3 THREE', 0
	Button_msg_4	DB	'4 FOUR', 0
	Button_msg_5	DB	'5 FIVE', 0
	Button_msg_6	DB	'6 SIX', 0
	Button_msg_7	DB	'7 SEVEN', 0
	Button_msg_8	DB	'8 EIGHT', 0
	Button_msg_9	DB	'9 NINE', 0
	Button_msg_0	DB	'0 ZERO', 0
	Button_msg_A	DB	'+ ADD', 0
	Button_msg_S	DB	'- SUB', 0
	Button_msg_M	DB	'x MUL', 0
	Button_msg_D	DB	' DIV', 0
	Button_msg_P	DB	'  CLEAR', 0
	Button_msg_E	DB	'= EQUAL', 0
;.................edit box
	EDIT_HANDLE_1	DW	0
	Edit_msg_1		DB	'0                ', 0
;.........................................................................
;.......................DisplayString procedure variables
;.........................................................................
	s_x_position	DW	0
	s_y_position	DW	0
	s_length		DW	0
	string_out 		DW	0
;.........................................................................
;.......................DisplayButton procedure variables
;.........................................................................
	Button_Class	DB	'button', 0
	BUTTON_ID		DW	0
	Button_Message	DW	0
	b_x_position	DW	0
	b_y_position	DW	0
	b_width		DW	0
	b_height		DW	0
;.........................................................................
;.......................DisplayEditBox procedure variables
;.........................................................................
	Edit_Class		DB	'edit', 0
	EDIT_ID		DW	?
	Edit_Message	DW	?
	e_x_position	DW	?
	e_y_position	DW	?
	e_width		DW	?
	e_height		DW	?
;.........................................................................
;.......................ConvertNumberToString procedure variables
;.........................................................................
	C_IN_NUMBER		DW	0
	C_OUT_STRING	DB	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
;.........................................................................
;.......................ConvertStringToNumber procedure variables
;.........................................................................
	C_OUT_NUMBER	DW	0
	C_IN_STRING		DB	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	number_array	DB	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	mul_value_1		DW	10
	mul_value_2		DW	100
	mul_value_3		DW	1000
	mul_value_4		DW	10000 
	num_char		DW	0
;.........................................................................
.CODE
;.........................................................................
;
;.........................................................................
PUBLIC WINMAIN					; 
WINMAIN PROC NEAR					; 
	push BP					; 
	mov BP, SP					; 
	sub SP, 46					; 
	cmp WORD PTR [BP + 10], 0		; 
	jne z_create_window			; 
	mov WORD PTR [BP - 46], 3		; 
	mov WORD PTR [BP - 44], offset WNDPROC
	mov AX, seg WNDPROC			; 
	mov [BP - 42], AX				; 
	mov AX, 0					; 
	mov [BP - 40], AX				; 
	mov [BP - 38], AX				; 
	mov AX, [BP + 12]				; 
	mov [BP - 36], AX				; 
	mov AX, [BP + 12]				; LOAD ICON use 0 if standard icon used 
	push AX					; 
	mov CX, WORD PTR ICON_ROAK		; path of icon
	mov DX, WORD PTR ICON_ROAK		; path of icon
	push DX					; 
	push CX					; 
	call LOADICON				; 
	mov [BP - 34], AX				; 
	mov AX, 0					; 
	push AX					; 
	mov AX, 7F00h				; IDC_ARROW = 32512  = standard cursor
	cwd						; in DX:AX
	push DX					; 
	push AX					; 
	call LOADCURSOR				; 
	mov [BP - 32], AX				; 
	mov AX, 6					; white background
	mov [BP - 30], AX				; 
	mov AX, offset szName			; name of
	mov [BP - 28], AX				; menu
	mov [BP - 26], DS				; 
	mov [BP - 24], AX				; class
	mov [BP - 22], DS				; 
	lea AX, [BP - 46]				; wndclass
	push	ss					; 
	push	ax					; 
	call REGISTERCLASS			; registers this class of window
	or AX, AX					;
	je z_quit_winmain				; 
;.........................................................................
z_create_window:					; MAIN WINDOW
	mov AX, offset szname			; name
	push DS					; 
	push AX					; 
	mov AX, OFFSET szWindowTitle		; title
	push DS					; 
	push AX					; 
	mov AX, 0					; type of window
	mov DX, 207					; 
	push DX					; 
	push AX					; 
	mov AX, 20					; x-coordinate
	push AX					; 
	mov AX, 20					; y-coordinate
	push AX					; 
	mov AX, 520					; width
	push AX					; 
	mov AX, 300					; height
	push AX					; 
	mov AX, 0					; 
	push AX					; 0 where there is no parent
	push AX					; 0 for class class
	mov AX, [BP + 12]				; 
	mov hInstance, AX				; save application's instance for children
	push AX					;
	mov AX, 0					; 
	push AX					;
	push AX					;
	call CREATEWINDOW				; 
	mov [BP - 2], AX				; returns hWnd in AX saved temporarily
	push ax					; ShowWindow requires hWnd and nCmdShow on the stack
	push WORD PTR [BP + 4]			; nCmdShow
	call SHOWWINDOW				; tells Windows to display window
	push WORD PTR [bp-2]			; hWnd
	call UPDATEWINDOW				; tells Windows to redraw now
	jmp z_message_loop			; go to the main message-loop
;.........................................................................
z_main_loop:					; MAIN MESSAGE LOOP
	lea AX, [BP - 20]				; far address of message
	push SS					; 
	push AX					; 
	call TRANSLATEMESSAGE			; 
	lea AX, [BP - 20]				; far address of message
	push SS					; 
	push AX					; 
	call DISPATCHMESSAGE			; 
;.........................................................................
z_message_loop:					; 
	lea AX, [BP - 20]				; long pointer to far address of message
	push SS					; 
	push AX					; 
	mov AX, 0					; 
	push AX					; null
	push AX					; null
	push AX					; null
	call GETMESSAGE				; 
	or AX, AX					; GetMessage returns FALSE or AX = 0 if exit	
	jne z_main_loop				; 
	mov AX, [BP - 16]				; return wParam to Windows
;.........................................................................
z_quit_winmain:					; 
	mov SP, BP					; 
	pop BP					; 
	ret 10					; causes RET to add 10 to SP after popping return address, effectively dumping all params under PASCAL convention
WINMAIN ENDP					; 
;.........................................................................
;
;.........................................................................
PUBLIC WNDPROC					; 
WNDPROC PROC FAR					; 
	push DS					; prolog code
	pop AX					;	"
	nop						;	"
	inc BP					;	"
	push BP					;	"
	mov BP, SP					;	"
	push DS					;	"
	mov DS, AX					;	"
	ASSUME DS: NOTHING			; enters function with DS = _DATA
	sub SP, 146					; move stack to free region so params not messed up
	mov AX, [BP + 12]				; get message type
;.........................................................................
	cmp AX, 1h					; 			WM_CREATE
	jne z_not_create				; 
	jmp z_create				; 
;.........................................................................
z_not_create:					; TASM QUIRK
	cmp AX, 2h					; 			WM_DESTROY 
	jne z_not_exit				; 
	jmp z_exit					; 
;.........................................................................
z_not_exit:						; TASM QUIRK
	cmp AX, 0Fh					; 			WM_PAINT
	jne z_not_paint				; 
	jmp z_paint					; 
;.........................................................................
z_not_paint:					; TASM QUIRK
	cmp AX, 100h				; 			WM_KEYDOWN
	jne z_not_keydown				; 
	jmp z_keydown				; 
;.........................................................................
z_not_keydown:					; TASM QUIRK 
	cmp AX, 102h				; 			WM_CHAR
	jne z_not_char				; 
	jmp z_char					;
;.........................................................................
z_not_char:						; TASM QUIRK
	cmp AX, 111h				; 			WM_COMMAND
	jne z_not_command				; 
	jmp z_command				; 
;.........................................................................
z_not_command:					; TASM QUIRK
	cmp AX, 113h				; 			WM_TIMER
	jne z_not_timer				; 
	jmp z_timer					; 
;.........................................................................
z_not_timer:					; TASM QUIRK
	cmp AX, 201h				; 			WM_LBUTTONDOWN
	jne z_not_lbuttondown			; 
	jmp z_lbuttondown				; 
;.........................................................................
z_not_lbuttondown:				; TASM QUIRK
	cmp AX, 204h				; 			WM_RBUTTONDOWN
	jne z_not_rbuttondown  			; 
	jmp z_rbuttondown				; 
;.........................................................................
z_not_rbuttondown:				; TASM QUIRK
	push WORD PTR [BP + 14]			; hWnd
	push WORD PTR [BP + 12]			; message type
	push WORD PTR [BP + 10]			; wParam
	push WORD PTR [BP + 8]			; high half of lParam
	push WORD PTR [BP + 6]			; low half of lParam
	call DEFWINDOWPROC			; 
	jmp z_party_over				; back to Windows, which will in turn return after DispatchMessage
;.........................................................................
z_create:						; 
; set timer with window handle, for 2000 = 2 seconds 
	CALL SetTimer PASCAL, WORD PTR [BP + 14], 1, 2000, 0, 0
;.........................................................................
	mov AX, 2001				; display button 1
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_1		; 
	mov Button_Message, AX			; 
	mov AX, 100					; 
	mov b_x_position, AX			; 
	mov AX, 40					; 
	mov b_y_position, AX			; 
	mov AX, 80					; 
	mov b_width, AX				; 
	mov AX, 25					; 
	mov b_height, AX				; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_1, AX			; 
;........................................................................
	mov AX, 2002				; display button 2
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_2		; 
	mov Button_Message, AX			; 
	mov AX, 190					; 
	mov b_x_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_2, AX			; 
;.........................................................................
	mov AX, 2003				; display button 3
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_3		; 
	mov Button_Message, AX			; 
	mov AX, 280					; 
	mov b_x_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_3, AX			; 
;........................................................................
	mov AX, 2004				; display button 4
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_4		; 
	mov Button_Message, AX			; 
	mov AX, 370					; 
	mov b_x_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_4, AX			; 
;.........................................................................
	mov AX, 2005				; display button 5
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_5		; 
	mov Button_Message, AX			; 
	mov AX, 100					; 
	mov b_x_position, AX			; 
	mov AX, 80					; 
	mov b_y_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_5, AX			;
;.........................................................................
	mov AX, 2006				; display button 6
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_6		; 
	mov Button_Message, AX			; 
	mov AX, 190					; 
	mov b_x_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_6, AX			;
;.........................................................................
	mov AX, 2007				; display button 7
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_7		; 
	mov Button_Message, AX			; 
	mov AX, 280					; 
	mov b_x_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_7, AX			;
;.........................................................................
	mov AX, 2008				; display button 8
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_8		; 
	mov Button_Message, AX			; 
	mov AX, 370					; 
	mov b_x_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_8, AX			;
;.........................................................................
	mov AX, 2009				; display button 9
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_9		; 
	mov Button_Message, AX			; 
	mov AX, 100					; 
	mov b_x_position, AX			; 
	mov AX, 120					; 
	mov b_y_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_9, AX			;
;.........................................................................
	mov AX, 2010				; display button 10 ZERO
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_0		; 
	mov Button_Message, AX			; 
	mov AX, 190					; 
	mov b_x_position, AX			;  
	call DisplayButton			; 
	mov BUTTON_HANDLE_0, AX			;
;.........................................................................
	mov AX, 2011				; display button 11 ADD
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_A		; 
	mov Button_Message, AX			; 
	mov AX, 280					; 
	mov b_x_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_A, AX			;
;.........................................................................
	mov AX, 2012				; display button 12 SUBTRACT
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_S		; 
	mov Button_Message, AX			; 
	mov AX, 370					; 
	mov b_x_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_S, AX			;
;.........................................................................
	mov AX, 2013				; display button 13 MULTIPLY
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_M		; 
	mov Button_Message, AX			; 
	mov AX, 100					; 
	mov b_x_position, AX			; 
	mov AX, 160					; 
	mov b_y_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_M, AX			;
;.........................................................................
	mov AX, 2014				; display button 14 DIVIDE
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_D		; 
	mov Button_Message, AX			; 
	mov AX, 190					; 
	mov b_x_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_D, AX			;
;.........................................................................
	mov AX, 2015				; display button 15 POINT
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_P		; 
	mov Button_Message, AX			; 
	mov AX, 280					; 
	mov b_x_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_P, AX			;
;.........................................................................
	mov AX, 2016				; display button 16 EQUAL
	mov BUTTON_ID, AX				; 
	mov AX, offset Button_msg_E		; 
	mov Button_Message, AX			; 
	mov AX, 370					; 
	mov b_x_position, AX			; 
	call DisplayButton			; 
	mov BUTTON_HANDLE_E, AX			;
;.........................................................................
	mov AX, 3001				; display edit box 1
	mov EDIT_ID, AX				; 
	mov AX, offset Edit_msg_1		; 
	mov Edit_Message, AX			; 
	mov AX, 100					; 
	mov e_x_position, AX			; 
	mov AX, 5					; 
	mov e_y_position, AX			; 
	mov AX, 350					; 
	mov e_width, AX				; 
	mov AX, 25					; 
	mov e_height, AX				; 
	call DisplayEditBox			; 
	mov EDIT_HANDLE_1, AX			; 
	jmp z_break					; 
;.........................................................................
z_exit:						; 
	mov AX, 0					; 
	push AX					; 
	call POSTQUITMESSAGE			; 
	jmp z_break					; 
;.........................................................................
z_paint:						; 
	mov AX, 100					; display string
	mov s_x_position, AX			; 
	mov AX, 200					; 
	mov s_y_position, AX			; 
	mov AX, 45					; string length
	mov s_length, AX				; 
	mov AX, offset FirstString		; 
	mov string_out, AX			; 
	call DisplayString			; 
	jmp z_break					;
;......................................................................... 
z_keydown:						; 
	jmp z_break					; 
;.........................................................................
z_char:						; 
	call Beep					; 
	jmp z_break					; 
;.........................................................................
z_timer:						; 
	mov AH, 2					; 
	mov DL, 7					; 
	call DOS3CALL				; 
	jmp z_break					;
;.........................................................................
z_lbuttondown:					;
	jmp z_break					; 
;.........................................................................
z_rbuttondown:					; 
; kill timer if right mouse button clicked 1. window handle, 2. 1 to kill
	call KILLTIMER PASCAL, WORD PTR [BP + 14], 1
	jmp z_break					;  
;.........................................................................
z_command:						; start with checking buttons
;.........................................................................
	cmp WORD PTR [BP + 10], 2001		; 		PRESS BUTTON ONE
	jne not_z_button_1			; 
	jmp z_button_1				; 
;.........................................................................
not_z_button_1:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2002		; 		PRESS BUTTON TWO
	jne not_z_button_2			; 
	jmp z_button_2				; 
;.........................................................................
not_z_button_2:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2003		; 		PRESS BUTTON THREE
	jne not_z_button_3			; 
	jmp z_button_3				; 
;.........................................................................
not_z_button_3:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2004		; 		PRESS BUTTON FOUR
	jne not_z_button_4			; 
	jmp z_button_4				; 
;.........................................................................
not_z_button_4:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2005		; 		PRESS BUTTON FIVE
	jne not_z_button_5			; 
	jmp z_button_5				; 
;.........................................................................
not_z_button_5:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2006		; 		PRESS BUTTON SIX
	jne not_z_button_6			; 
	jmp z_button_6				; 
;.........................................................................
not_z_button_6:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2007		; 		PRESS BUTTON SEVEN
	jne not_z_button_7			; 
	jmp z_button_7				; 
;.........................................................................
not_z_button_7:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2008		; 		PRESS BUTTON EIGHT
	jne not_z_button_8			; 
	jmp z_button_8				; 
;.........................................................................
not_z_button_8:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2009		; 		PRESS BUTTON NINE
	jne not_z_button_9			; 
	jmp z_button_9				; 
;.........................................................................
not_z_button_9:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2010		; 		PRESS BUTTON TEN
	jne not_z_button_10			; 
	jmp z_button_10				; 
;.........................................................................
not_z_button_10:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2011		; 		PRESS BUTTON ELEVEN
	jne not_z_button_11			; 
	jmp z_button_11				; 
;.........................................................................
not_z_button_11:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2012		; 		PRESS BUTTON TWELVE
	jne not_z_button_12			; 
	jmp z_button_12				; 
;.........................................................................
not_z_button_12:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2013		; 		PRESS BUTTON THIRTEEN
	jne not_z_button_13			; 
	jmp z_button_13				; 
;.........................................................................
not_z_button_13:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2014		; 		PRESS BUTTON FOURTEEN
	jne not_z_button_14			; 
	jmp z_button_14				; 
;.........................................................................
not_z_button_14:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2015		; 		PRESS BUTTON FIFTEEN
	jne not_z_button_15			; 
	jmp z_button_15				; 
;.........................................................................
not_z_button_15:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 2016		; 		PRESS BUTTON SIXTEEN
	jne not_z_button_16			; 
	jmp z_button_16				; 
;.........................................................................
not_z_button_16:					; TASM QUIRK
	cmp WORD PTR [BP + 6], 0		; low half of lParam
	je not_z_break				; check menus last
	jmp z_break					; 
;.........................................................................
not_z_break:					; TASM QUIRK
	cmp WORD PTR [BP + 10], 1000		; IDM_EXIT = MENU EXIT in *.rc 
	jne not_z_exit				; 
	jmp z_exit					; 
;.........................................................................
not_z_exit:						; TASM QUIRK
	cmp WORD PTR [BP + 10], 1001		; IDM_ROAK = MENU ROAK in *.rc 
	jne not_z_roak				; 
	jmp z_roak					; 
;.........................................................................
not_z_roak:						; TASM QUIRK
	cmp WORD PTR [BP + 10], 1002		; IDM_CALC = MENU CALC in *.rc 
	jne not_z_calc				; 
	jmp z_calc					; 
;.........................................................................
not_z_calc:						; TASM QUIRK
	cmp WORD PTR [BP + 10], 1003		; IDM_INFO = MENU INFO in *.rc 
	jne not_z_info				; 
	jmp z_info					; 
;.........................................................................
not_z_info:						; TASM QUIRK
	cmp WORD PTR [BP + 10], 1004		; IDM_ABOUT	= ABOUT MESSAGEBOX in *.rc
	jne not_z_about				; 
	jmp z_about					;
;.........................................................................
not_z_about:					; TASM QUIRK
;.........................................................................
z_button_1:						; RESPONSE TO BUTTON 1 DEPRESSION
	mov AX, 49					; 1
	mov button_number, AX			; 
	call PressButton				; 
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14]
	jmp z_break 				; 
;.........................................................................
z_button_2:						; RESPONSE TO BUTTON 2 DEPRESSION
	mov AX, 50					; 2
	mov button_number, AX			; 
	call PressButton				; 
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14]
	jmp z_break 				; 
;.........................................................................
z_button_3:						; RESPONSE TO BUTTON 3 DEPRESSION 
	mov AX, 51					; 3
	mov button_number, AX			; 
	call PressButton				;
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14]
	jmp z_break 				; 
;.........................................................................
z_button_4:						; RESPONSE TO BUTTON 4 DEPRESSION
	mov AX, 52					; 4
	mov button_number, AX			; 
	call PressButton				;
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_5:						; RESPONSE TO BUTTON 5 DEPRESSION
	mov AX, 53					; 5
	mov button_number, AX			; 
	call PressButton				;
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_6:						; RESPONSE TO BUTTON 6 DEPRESSION
	mov AX, 54					; 6
	mov button_number, AX			; 
	call PressButton				;
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_7:						; RESPONSE TO BUTTON 7 DEPRESSION
	mov AX, 55					; 7
	mov button_number, AX			; 
	call PressButton				;
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_8:						; RESPONSE TO BUTTON 8 DEPRESSION
	mov AX, 56					; 8
	mov button_number, AX			; 
	call PressButton				;
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_9:						; RESPONSE TO BUTTON 9 DEPRESSION
	mov AX, 57					; 9
	mov button_number, AX			; 
	call PressButton				;
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_10:					; RESPONSE TO BUTTON 10 DEPRESSION
	mov AX, 48					; 0
	mov button_number, AX			; 
	call PressButton				;
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_11:					; RESPONSE TO BUTTON 11 DEPRESSION
	mov AX, 0					; +
	mov counter, AX				; 
	mov what_operation, AX			; 
	inc which_operand				; 
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_12:					; RESPONSE TO BUTTON 12 DEPRESSION
	mov AX, 0					; -
	mov counter, AX				; 
	mov AX, 1					; 
	mov what_operation, AX			;
	inc which_operand				; 
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_13:					; RESPONSE TO BUTTON 13 DEPRESSION
	mov AX, 0					; x
	mov counter, AX				; 
	mov AX, 2					; 
	mov what_operation, AX			;  
	inc which_operand				; 
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_14:					; RESPONSE TO BUTTON 14 DEPRESSION
	mov AX, 0					; 
	mov counter, AX				; 
	mov AX, 3					; 
	mov what_operation, AX			;
	inc which_operand				;  
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_15:					; RESPONSE TO BUTTON 15 DEPRESSION
	mov AX, 0					; CLEAR
	mov counter, AX				; 
	mov which_operand, AL			; 
	call ClearFlush				; flush
; 1. handle, 2. WM_SETTEXT = 12, 3. 32 bytes of input, 4. DS, 5. output
	call SENDMESSAGE PASCAL, EDIT_HANDLE_1, 0Ch, 32, DS, offset C_OUT_STRING
; 1. handle, 2. WM_SETTEXT = 12, 3. 32 bytes of input, 4. DS, 5. output
	call SENDMESSAGE PASCAL, EDIT_HANDLE_1, 0Ch, 32, DS, offset Edit_msg_1
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_button_16:					; RESPONSE TO BUTTON 16 DEPRESSION
	mov AX, what_operation			; =
	cmp AL, 0					; 
	je z_op_add					; 
	cmp AL, 1					; 
	je z_op_sub					; 	
	cmp AL, 2					; 
	je z_op_mul					; 
	cmp AL, 3					; 
	je z_op_div					; 
z_op_add:						; 
	mov AX, [first_operand]			; +
	add AX, [second_operand]		;
	jmp z_out_a_here				; 
z_op_sub:						; -
	mov AX, [first_operand]			; 
	sub AX, [second_operand]		; 
	jmp z_out_a_here				; 
z_op_mul:						; x
	mov AX, [first_operand]			; 
	mul [second_operand]			; 
	jmp z_out_a_here				; 
z_op_div:						; 
	mov AX, [first_operand]			; 
	mov CX, 1					; 
	mul CX					; 
	div [second_operand]			;  
z_out_a_here:					; 
	call ConvertNumberToString		; 
; 1. handle, 2. WM_SETTEXT = 12, 3. 32 bytes of input, 4. DS, 5. output
	call SENDMESSAGE PASCAL, EDIT_HANDLE_1, 0Ch, 32, DS, offset C_OUT_STRING
	mov AX, 0					; 
	mov which_operand, AL			; 
	mov counter, AX				; 
;.........................................................................
; if you wish to continue calculating the following code helps else clear
;.........................................................................
; 1. handle, 2. WM_GETTEXT = 13, 3. 32 bytes of input, 4. DS, 5. intput
	call SENDMESSAGE PASCAL, EDIT_HANDLE_1, 0Dh, 32, DS, offset C_IN_STRING
	call ConvertStringToNumber		;
	mov AX, C_OUT_NUMBER			; 
	mov first_operand, AX			; 
; set focus to window after button press	; set focus
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				; 
;.........................................................................
z_roak:						; 
; play sound, 0 for SND_SYNC		 	; 
	call SNDPLAYSOUND PASCAL, DS, OFFSET wave_path, 0
	cmp AX, 1					; 
	je z_sound_ok				; 
; display message if wave file not found	; 
	call MESSAGEBOX PASCAL, WORD PTR [BP + 14], DS, offset WarningMessage, DS, offset WarningTitle, 0
z_sound_ok:						; 
	jmp z_break					; 
;.........................................................................
z_calc:						; 
; execute p:\winnt\system32\calc.exe 10 for show default
	call WINEXEC PASCAL, DS, offset calc_path, 10
	cmp AX, 31					; 
	jg z_exec_ok				; 
; try to execute c:\windows\calc.exe 10 for show default
	call WINEXEC PASCAL, DS, offset calc_path_w, 10
	cmp AX, 31					; 
	jg z_exec_ok				; 
; display message if calc.exe not found	; 
	call MESSAGEBOX PASCAL, WORD PTR [BP + 14], DS, offset WarningMessage, DS, offset WarningTitle, 0
z_exec_ok:						; 
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break					; 
;.........................................................................
z_info:						; 
	call MESSAGEBOX PASCAL, WORD PTR [BP + 14], DS, offset InfoMessage, DS, offset InfoTitle, 0
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break					; 
;.........................................................................
z_about:						; 
	call MESSAGEBOX PASCAL, WORD PTR [BP + 14], DS, offset AboutMessage, DS, offset AboutTitle, 0
; set focus to window after button press	; 
	call SETFOCUS PASCAL, WORD PTR [BP + 14] 
	jmp z_break 				;
;......................................................................... 
z_break:						; 
	mov AX, 0					; returns 0 in DX:AX callback function
	cwd						;	"
;.........................................................................
z_party_over:					; 
	dec BP					; final standard manipulation of registers aka epilog code
	dec BP					;	"
	mov SP, BP					;	"
	pop DS					;	"
	pop BP					;	"
	dec BP					;	"
	ret 10					; removes parameters
WNDPROC ENDP					; 
;.........................................................................
;
;.........................................................................
DisplayString PROC				;
	push WORD PTR [BP + 14]			; 1. hWnd -- handle of window
	lea AX, [BP - 42]				; 2. address of paint structure
	push	ss					; 
	push	ax					; 
	call	BEGINPAINT				; BeginPaint returns handle hDC
	mov [BP - 146], AX			; 1. hDC -- device context
	push WORD PTR [BP - 146] 		; 
	mov AX, s_x_position			; 2. x-coordinate
	push AX					; 
	mov AX, s_y_position			; 3. y-coordinate
	push AX					;
	mov AX, string_out			; 4. address of string
	push DS					; 	high part
	push AX					; 	low part
	mov AX, s_length				; 5. # of chars in string
	push AX					; 
	call TEXTOUT				; TestOut
	push WORD PTR [BP + 14]			; 1. hWnd
	lea AX, [BP - 42]				; 2. address of paint structure
	push SS					; 
	push AX					; 
	call ENDPAINT				; EndPaint marks end of painting
	ret						;
DisplayString ENDP				;
;.........................................................................
;
;.........................................................................
DisplayButton PROC				;
	mov AX, OFFSET Button_Class		;  1. class name = button
	push DS					; 
	push AX					; 
	mov AX, Button_Message			;  2. button text 
	push DS					; 
	push AX					; 
	mov AX, 0					;  3. type = child window
	mov DX, 4000h or 1000h or 0h		;	high word for child window
	push DX					;	high word 1000h = WS_VISIBLE, 4000h = WS_CHILD, 0 = BS_PUSHBUTTON
	push AX					;	low word
	mov AX, b_x_position			;  4. x-position
	push AX					;	"
	mov AX, b_y_position			;  5. y-position
	push AX					;	"
	mov AX, b_width				;  6. width 
	push AX					;	"
	mov AX, b_height				;  7. height 
	push AX					;	"
	mov AX, WORD PTR [BP + 14]		;  8. parent handle hWnd
	push AX					; 
	mov AX, BUTTON_ID				;  9. ID
	push AX					; 
	mov AX, hInstance				; 10. instance handle hInstance 
	push AX					; 
	mov AX, 0					; 11. null
	push AX					; 
	mov AX, 0					;
	push AX					; 
	call CREATEWINDOW				; 
	ret						; 
DisplayButton ENDP				; 
;.........................................................................
;
;.........................................................................
DisplayEditBox PROC				; 
	mov AX, OFFSET Edit_Class		;  1. class name = edit
	push DS					; 
	push AX					; 
	mov AX, Edit_Message			;  2. edit box text 
	push DS					; 
	push AX					; 
	mov AX, 0					;  3. type = child window
	mov DX, 4000h or 1000h or 80h	or 4h	;	high word for child window
	push DX					;	high word 4h = multiline, 80h = WS_BORDER, 1000h = WS_VISIBLE, 4000h = WS_CHILD, 
	push AX					;	low word
	mov AX, e_x_position			;  4. x-position
	push AX					;	"
	mov AX, e_y_position			;  5. y-position
	push AX					;	"
	mov AX, e_width				;  6. width 
	push AX					;	"
	mov AX, e_height				;  7. height 
	push AX					;	"
	mov AX, WORD PTR [BP + 14]		;  8. parent handle hWnd
	push AX					; 
	mov AX, EDIT_ID				;  9. ID
	push AX					; 
	mov AX, hInstance				; 10. instance handle hInstance 
	push AX					; 
	mov AX, 0					; 11. null
	push AX					; 
	mov AX, 0					; 
	push AX					; 
	call CREATEWINDOW				; 
	ret						; 
DisplayEditBox ENDP				; 
;.........................................................................
;
;.........................................................................
ConvertStringToNumber PROC			; 
	lea si, C_IN_STRING			; DS:SI contains array
	mov CX, 16					; size of array
count_characters:					; start loop
	lodsb						; load byte into AL from DS:SI
	cmp AL, 48					; 
	jl exit_count_characters		; 
	cmp AL, 57					; 
	jg exit_count_characters		; 
	dec CX					; 
	cmp CX, 0					; 
	jne count_characters			; 
exit_count_characters:				; 
	mov num_char, 16				; 
	sub num_char, CX				; 
;.........................................................................
	mov C_OUT_NUMBER, 0			; convert char array to byte array
	mov CX, num_char				; loop CX times
	mov BX, num_char				; maximum string array value
	dec BX					; this is an array
convert_characters_to_byte_array_loop:	; start loop
	mov AL, C_IN_STRING[BX]			; get character
	sub AL, 48					; convert character to digit
	mov number_array[BX], AL		; store in byte array
	dec BX					; decrement high counter 
	loop convert_characters_to_byte_array_loop
;.........................................................................
	mov CX, num_char				; convert byte array to word
	mov BX, 0					; index
convert_byte_array_to_number:			; start loop
	mov AL, number_array[BX]		; put byte into AL
	mov AH, 0					; clear AH
	cmp CX, 1					; COUNT ONE
	jne not_1					; 
	add C_OUT_NUMBER, AX			; 
not_1:						; 
	cmp CX, 2					; COUNT TWO
	jne not_2					; 
	mul mul_value_1				; 10
	add C_OUT_NUMBER, AX			; 
not_2:						; 
	cmp CX, 3					; COUNT THREE
	jne not_3					; 
	mul mul_value_2				; 100
	add C_OUT_NUMBER, AX			; 
not_3:						; 
	cmp CX, 4					; COUNT FOUR
	jne not_4					; 
	mul mul_value_3				; 1000
	add C_OUT_NUMBER, AX			; 
not_4:						; 
	cmp CX, 5					; COUNT FIVE
	jne not_5					; 
	mul mul_value_4				; 10000
	add C_OUT_NUMBER, AX			; 
not_5:						; 
	inc BX					; increment index
	loop convert_byte_array_to_number	; 
	ret						; 
ConvertStringToNumber ENDP			; 
;.........................................................................
;
;.........................................................................
ConvertNumberToString PROC			; 
	mov C_IN_NUMBER, AX			; number to be displayed
	mov BX, 10					; 
	mov CX, 0					; 
fill_stack_loop_nts:				; 
	mov DX, 0					; 
	div BX					; 
	push DX					; 
	inc CX					; 
	cmp AX, 0					; 
	jne fill_stack_loop_nts			;  
	mov BX, 0					; 
empty_stack_loop_nts: 				; 
	pop DX					; 
	mov AX, DX					; 
	add AL, 48					; 
	mov C_OUT_STRING[BX], AL		; 
	inc BX					; 
	loop empty_stack_loop_nts		;  
	mov C_OUT_STRING[BX], 0			; make string null terminated
	ret						; 
ConvertNumberToString ENDP			; 
;.........................................................................
;
;.........................................................................
PressButton PROC					; 
	mov AL, which_operand			; 
	cmp AL, 1					; 
	jne z_no_clear				;
	call ClearFlush				; flush 
z_no_clear:						; 
	mov BX, counter				; 
	mov AX, button_number			; 
	mov INPUT[BX], AL				; 
	inc counter					; 
	mov BX, 0					; 
	mov CX, counter				; 
transfer_loop:					; fill C_OUT_STRING
	mov AL, INPUT[BX]				; 
	mov C_OUT_STRING[BX], AL		; 
	inc BX					; 
	loop transfer_loop			; 
; 1. handle, 2. WM_SETTEXT = 12, 3. 32 bytes of input, 4. DS, 5. output
	call SENDMESSAGE PASCAL, EDIT_HANDLE_1, 0Ch, 32, DS, offset C_OUT_STRING
;..........................................................................
; 1. handle, 2. WM_GETTEXT = 13, 3. 32 bytes of input, 4. DS, 5. intput
	call SENDMESSAGE PASCAL, EDIT_HANDLE_1, 0Dh, 32, DS, offset C_IN_STRING
	call ConvertStringToNumber		; 
	mov AL, which_operand			; 
	cmp AL, 0					; 
	jne z_is_second_operand			; 
	mov AX, C_OUT_NUMBER			; 
	mov first_operand, AX			; 
	jmp z_not_second_operand		; 
z_is_second_operand:				; 
	mov AX, C_OUT_NUMBER			; 
	mov second_operand, AX			; 
z_not_second_operand:				; 
	ret						; 
PressButton ENDP					; 
;.........................................................................
;
;.........................................................................
ClearFlush PROC					; 
	mov CX, 15					; 
	mov BX, 0					; 
z_clear_loop:					; flush C_OUT_STRING if necessary
	mov AL, 0					; 
	mov C_OUT_STRING[BX], AL		; 
	inc BX					; 
	loop z_clear_loop				; 
	ret						; 
ClearFlush ENDP					; 
;.........................................................................
;
;.........................................................................
Beep PROC						; 
	mov AL, 182					; 
	out 43h, AL					; 
	mov AX, 2711				; 1193180 / 440Hz 
	out 42h, AL					; 
	mov AL, AH					; 
	out 42h, AL					; 
	in AL, 61h					; 
	or AL, 11b					; 
	out 61h, AL					; beep is played 
	mov CX, 15					; 
	mov DX, 0					; 
	mov AH, 86h					; 
	int 15h					; wait for about 1 sec 
	in AL, 61h					; 
	and AL, 11111100b				; 
	out 61h, AL					; finish the tune 
	ret						; 
Beep ENDP						; 
;.........................................................................
;
;.........................................................................
END 							;
